export function Tangshan(money, c, name, CompositeTable, headRow, researchs) {
    //money 总金额  c导入表所有数据,name 来源类别,CompositeTable 材料汇总表数据, headRow 数据行
    let results = ['金属厂']
    let insert = CompositeTable[0].celldata.filter(obj => obj.v.v == '7.代付单位（XXX单位）')[0].r
    for (let i = 0, k = 0; i < CompositeTable[0].celldata.length && k < results.length; i++) {
        if (CompositeTable[0].celldata[i] && CompositeTable[0].celldata[i].r && CompositeTable[0].celldata[i].r >= insert + 1 && CompositeTable[0].celldata[i].r < insert + 4 && CompositeTable[0].celldata[i].c == 0) {
            CompositeTable[0].celldata[i].v.v = results[k];
            CompositeTable[0].celldata[i].v.m = results[k];
            k++;
        }
    }
    function findValueInArray(arr, value) {
        for (let obj of arr) {
            if (JSON.stringify(obj).includes(value)) {
                return obj;
            }
        }
        return null;
    }
    let targetValue = "器材大类";
    let resultObject = findValueInArray(c, targetValue);
    let material = c.flat().filter(obj => obj.c && obj.c == resultObject.c && obj.r > headRow)
    money.forEach(entry => {
        entry.department = '';
        entry.v.name = '';
        entry.v.material = '';
        entry.index = entry.r
    });
    // 匹配赋值
    for (let i = 0; i < money.length; i++) {
        if (money[i].r == name[i].r) {
            money[i].v.name = name[i].v.v;
        }
        if (money[i].r == material[i].r) {
            money[i].v.material = material[i].v.v;
        }
    }
    //对费用来源列和材料分类列进行处理
    money.forEach(obj => {
        if (!obj.v.material) {
            obj.v.material = '其他材料'
        }
        if (obj.v.name == '基本生产' || obj.v.name == '制造费用') {
            obj.v.name += '-原煤'
        }
        if (obj.v.name.includes('洗煤')) {
            obj.v.name = '基本生产-洗煤'
        }
        if (obj.v.name=='办公费用') {
            obj.v.name = '管理费用-'
        }
        if (obj.v.name == '其他业务成本') {
            obj.v.name += '-厂区服务'
        }
        
        if (obj.v.name == '其他费用') {
            obj.v.name = '代付单位（XXX单位）-金属厂'
        }
        // 如果不包含连字符，就在末尾添加一个连字符
        if (obj.v.name.indexOf('-') === -1) {
            obj.v.name += '-';
        }
    })

    //材料分类列和汇总列数值一样的话，列数就一样
    money.forEach(obj => {
        CompositeTable[0].celldata.forEach(cell => {
            if (obj.v.material == cell.v.v) {
                obj.c = cell.c
            }
        })
    })

    money.forEach(item => {
        if (item.v.name !== undefined) {
            let index = item.v.name.indexOf("-");
            if (index !== -1) {
                let substrBeforeDash = item.v.name.slice(0, index);
                let DepartColumns = CompositeTable[0]["celldata"].flat().filter(obj => {
                    if (obj.v && obj.v.v && typeof obj.v.v === 'string') {
                        return obj.v.v.includes(item.v.name.slice(0, index));
                    }
                    return false;
                })[0];

                if (DepartColumns && DepartColumns.r) {
                    let index = item.v.name.indexOf("-");
                    if (index !== -1) {
                        let substrAfterDash = item.v.name.slice(index + 1);
                        switch (substrAfterDash) {
                            case '':
                                item.r = DepartColumns.r;
                                break;
                            case '原煤':
                                item.r = DepartColumns.r + 1;
                                break;
                            case '洗煤':
                                item.r = DepartColumns.r + 2;
                                break;
                            case '选煤':
                                item.r = DepartColumns.r + 3;
                                break;
                            case '厂区服务':
                                item.r = DepartColumns.r + 1;
                                break;
                            case '加工修理':
                                item.r = DepartColumns.r + 4;
                                break;
                            case '金属厂':
                                item.r = DepartColumns.r + 1
                            default:
                            // 默认情况
                        }
                    }
                }
            }
        }
    });
    // 同一个单元格，金额相加
    let seen = new Map();
    let duplicateData = []
    money.forEach((obj) => {
        let key = obj.r + ',' + obj.c;
        if (seen.has(key)) {
            let existingObj = seen.get(key);
            existingObj.v.v = Number(existingObj.v.v) + Number(obj.v.v);
            existingObj.v.m = existingObj.v.v.toString();
            existingObj.index.push(obj.index);
        } else {
            obj.index = [obj.index];
            seen.set(key, obj);
        }
    });

    seen.forEach(obj => {
        if (Math.abs(obj.v.v) > 0 || Math.abs(parseInt(obj.v.m)) > 0) {
            duplicateData.push(obj);
        }
    });
    duplicateData = duplicateData.map(item => {
        return {
            ...item,
            v: {
                ...item.v,
                v: isNaN(item.v.v) ? item.v.v : Number(item.v.v).toFixed(2),
                m: Number(item.v.m).toFixed(2)
            }
        };
    });
    duplicateData.forEach(item => {
        const Fusion = {
            "r": '',
            "c": '',
            "v": {
                "ct": {
                    "fa": "@",
                    "t": "s"
                },
                "fs": 8,
                "ff": "微软雅黑",
                "tb": 2,
                "v": "",
                "qp": 1,
                "m": ""
            }
        };
        Fusion.r = item.r
        Fusion.c = item.c
        Fusion.v.v = item.v.v
        Fusion.v.m = item.v.v
        CompositeTable[0]["celldata"].push(Fusion)
    })
    let duplicateJSON = JSON.stringify(duplicateData)
    duplicateJSON = JSON.parse(duplicateJSON)
    duplicateJSON.forEach(item => {
        if (item.r > 9) {
            item.c = 10
        }
    })
    let duplicateDatas = {
        duplicateData: duplicateJSON,
        CompositeTable: CompositeTable
    }
    return duplicateDatas
}