/*
  data必填  luckysheet.transToData(lucksheetfile.sheets[1].celldata) 或者 lucksheetfile.sheets[1].data
  非必填  默认值
  setting{
      startRow:0, //开始行
      endRow:infinity, //结束行
      startColumn:0, //开始列
      startColumn:infinity,//结束列
      titleR: undefined, //标题行
      cover：'',  //如果列名重复的情况应该如何处理 ,如果没有值就直接覆盖掉,有值返回的就是  [列名 + cover]
  }
* */
import { v4 as uuidv4 } from "uuid";

import { getyy } from "@/api/ruoyi-myLuckyexcel/myluckyexcel"
import { getMineProofConfig, kNameID } from "@/utils/MineProofConfig"
export class CreateNewCellData {
    constructor(cellData) {
        this.data = cellData;
        this.lasti = 0;
        // 缓存 值对应的 行和列
        this.cacheV = {}
        // 缓存  行和列 值对应的
        this.cacheRC = {}
    }
    buildcache(fn, ...args) {
        if (this.lasti >= this.data.length) { return fn(...args) }
        for (this.lasti; this.lasti < this.data.length; this.lasti++) {
            let cell = this.data[this.lasti];
            if (cell && cell.v && cell.v.v) {
                let cacheKey = String(cell.v.v).replaceAll(' ', '');
                let obj = { r: cell.r, c: cell.c, v: cell.v.v }
                this.cacheRC[`${cell.r},${cell.c}`] = cell.v.v;
                if (this.cacheV[cacheKey]) {
                    this.cacheV[cacheKey].push(obj)
                } else { this.cacheV[cacheKey] = [obj] }
                if (fn(...args)) {
                    return fn(...args)
                }
            }
        }
    }
    // n匹配的第几个, all 是否为强制匹配默认是true
    getCellV(v, n = 0) {
        v = String(v).replaceAll(' ', '');
        if (['undefined', 'null', ''].includes(v)) { return; }
        let fn = (v, n) => this.cacheV[v] && this.cacheV[v][n]
        if (fn(v, n)) { return fn(v, n) }
        else {
            return this.buildcache(fn, v, n)
        }
    }
    // key 值 (r,c)
    getCellRC(key) {
        let fn = (key) => this.cacheRC[key]
        if (fn(key)) {
            return fn(key)
        } else if (this.buildcache(fn, key)) {
            return this.buildcache(fn, key)
        }
    }
}
// 获取项目行
export function setXRow(arr, c = 0, chong = '--干部') {
    let obj = {}
    arr.forEach((item, rowIndex) => {
        // rowIndex 代表第几行
        if (item && item[c] && item[c].v) {
            if (obj[item[c].v]) {
                obj[item[c].v + chong] = rowIndex
            } else {
                obj[item[c].v] = rowIndex
            }
        }
    })
    return obj;
}
// 获取列 r是低几行
export function setXColumn(arr, r = 0, chong = '--干部', sc = 0, se = 9999) {
    let obj = {}
    arr[r].forEach((item, column) => {
        if (item && item.v && column >= sc && column <= se) {
            if (obj[item.v]) {
                obj[item.v + chong] = column
            } else {
                obj[item.v] = column
            }
        }
    })
    return obj;
}

export function transformJson(json) {
    let obj = {}
    json.loan.concat(json.borrow).forEach(item => {
        if (!obj.hasOwnProperty(item.classary)) { obj[item.classary] = { borrow: [], loan: [] } }
        item.is_debit === 0 ? obj[item.classary].borrow.push(item) : obj[item.classary].loan.push(item)
    })
    return obj
}
export function getyyData(sum, kid = '') {
    let conFigList = getMineProofConfig(kNameID[kid] || 'tsk')
    let allAll = []
    let err = []
    conFigList.forEach(cong => {
        let sheets = sum.find(item => item.name.includes(cong.sheetsName))
        if (!sheets || !cong.sheetsName) {
            err.push(cong)
            return;
        }
        let cellData = sheets && sheets.celldata || [];
        let newCellData = new CreateNewCellData(cellData)
        let data = sheets && sheets.data || luckysheet.transToData(cellData)
        let columnCell = newCellData.getCellV(cong.oldColumnName); //获取列单元格
        let endList = newCellData.getCellV('合计', cong.jishuhang || 0); //获取 “v是合计的” 单元格数组
        let itemCellColumn = newCellData.getCellV(cong.itemName || '项目');
        if (!columnCell || !endList || !itemCellColumn) {
            return
        }
        //获取项目的单元格的列数
        let itemCellColumnIndex = itemCellColumn.c;
        // 取那一列的数
        let columnIndex = columnCell.c;
        // 开始行是那一行
        let startRowIndex = columnCell.r;
        // 结束行是那一行
        let endRowIndex = endList.r;
        for (let currentRowIndex in data) {
            if (currentRowIndex >= endRowIndex) { break; }
            let rowList = data[currentRowIndex];
            if (currentRowIndex > startRowIndex) {
                let name = rowList[itemCellColumnIndex] && rowList[itemCellColumnIndex].v
                let money = rowList[columnIndex] && rowList[columnIndex].m || rowList[columnIndex].v
                let isFilterStartsWith = cong.isFilterStartsWith !== false && /^\d/.test(name && name.replace && name.replace(/\s+/g, ''))
                if (Number(money) > 0 && !isFilterStartsWith) {
                    allAll.push({
                        classary: cong.classary,
                        money,
                        name,
                    })
                }
            }
        }
    })
    if (err.length) {
    }
    return allAll
}
// 生成凭证第二步调取后端数据
export function newGettransformJson(sum, kid) {
    let schoolLunchValues = getyyData(sum, kid)
    let borrow = []; //借方
    let analyzedBorrow = [];//借方待分析
    let loan = [];//贷方
    let analyzedLoan = [];//贷方待分析
    schoolLunchValues.forEach(item => {
        if (!item.name.includes('研发')) {
            let obj = { ...item, is_debit: 0, mining: '010101' }
            borrow.push(obj)
            let analyzedBorrowObj = { ...obj }
            analyzedBorrowObj.classary = analyzedBorrowObj.classary.replace('提取', '待分析');
            analyzedBorrow.push(analyzedBorrowObj)
        }
        if (!item.name.includes('(') || !item.name.includes('（')) {
            let obj1 = { ...item, is_debit: 1, mining: '010101' }
            loan.push(obj1);
            let analyzedLoanObj = { ...obj1 }
            analyzedLoanObj.classary = analyzedLoanObj.classary.replace('提取', '待分析');
            analyzedLoan.push(analyzedLoanObj)
        }
    })
    let objJson = { borrow, loan, analyzedLoan, analyzedBorrow }
    return getyy(JSON.stringify(objJson))
}
// 生成凭证第三步生成凭证luckysheet.create.Data的数据
export function tzcCreateData(old2, json, luckysheet, mobile, ywrq) {
    let sum = 0
    let old = old2[0]
    old2[1].index = 99;
    old2[1].order = 99;
    old2[2].index = 100;
    old2[2].order = 100;
    return Object.entries(json).map(([key, json], index) => {
        let obj = JSON.parse(JSON.stringify(old));
        let toData = luckysheet.transToData(obj.celldata)
        let columnObj = setXColumn(toData, 5);
        obj.name = key;
        obj.index = index + 3;
        obj.order = index + 3;
        let uuid = uuidv4().replace(/-/g, "").substring(0, 12);
        function vule(v, fc) { return { ct: { fa: '@', t: 's' }, v, fc: fc } }
        json.loan.concat(json.borrow).filter(item => item.account_code).forEach((item, rowIndex) => {
            // item的值如下
            // "is_debit": 1,
            // "money": 20253.59894800332,
            // "auxiliary_item_a": "薪酬类别:01_CW0017_1003P/短期薪酬",
            // "classary": "提取住房公积金",
            // "auxiliary_item_b": "薪酬列支渠道:010102_CW0018_100QI/洗煤",
            // "name": "基本生产-洗煤-自产",
            // "account_code": "2211005",
            // "mining": "010101"

            toData[rowIndex + 9] = [];
            toData[rowIndex + 9][columnObj['制单人']] = vule(mobile);
            toData[rowIndex + 9][columnObj['*制单人']] = vule(mobile);
            toData[rowIndex + 9][columnObj['*会计主体']] = vule(item.mining);
            toData[rowIndex + 9][columnObj['*核算账簿']] = vule(item.mining);
            toData[rowIndex + 9][columnObj['*分录摘要']] = vule(item.classary);
            toData[rowIndex + 9][columnObj['*凭证类型']] = '转';
            toData[rowIndex + 9][columnObj['*单据日期']] = vule(ywrq)
            let money = String(item.money).replace(' ', '');
            toData[rowIndex + 9][columnObj[item.is_debit === 0 ? '本币借方金额' : '本币贷方金额']] = vule(money);
            toData[rowIndex + 9][columnObj[item.is_debit === 0 ? '原币借方金额' : '原币贷方金额']] = vule(money);
            toData[rowIndex + 9][columnObj['*科目编码']] = vule(item.account_code || '');
            ['auxiliary_item_a', 'auxiliary_item_b'].forEach(itemKey => {
                if (item[itemKey]) {
                    let [key, value] = item[itemKey].split(':')
                    if (key === '物料基本分类') {
                        key = '物料基本分类--干部'
                    }
                    value = value && value.split('/') && value.split('/')[0]
                    toData[rowIndex + 9][columnObj[key]] = vule(value);
                }
            })
            // 还要修改的
            toData[rowIndex + 9][columnObj['*币种']] = vule('CNY');
            toData[rowIndex + 9][columnObj['本币汇率类型']] = vule('E001');
            toData[rowIndex + 9][columnObj['*本币汇率']] = vule('1.00000000', 'red');
            toData[rowIndex + 9][columnObj['*手工码']] = vule(uuid);
            toData[rowIndex + 9][columnObj['*业务日期']] = vule(new Date().getFullYear() + '-' + (new Date().getMonth() + 1) + '-' + new Date().getDate());
        })
        obj.celldata = luckysheet.transToCellData(toData)
        return obj;
    }).concat(old2.slice(1))
}
export function getDataValue(data,m) {
    let value = data && data.v || '';
    if (m){
        value = data && data.m || '';
    }
    if (data && data.ct && data.ct.s && data.ct.s.length) {
        value = data.ct.s.map(e =>{
            let as= e.v || ''
            if (m){
                as = e.m
            }
            return as
        }).join('');
    }

    return value;
}
export function collect(data) {
    data.forEach(item =>
        item.data = luckysheet.transToData(item.celldata)
    )
    let collects = JSON.parse(JSON.stringify(data[0]))
    collects.name = '汇总'
    collects.index = data.length + 10
    collects.order = 98
    for (let i = 1; i < data.length; i++) {
        data[i].data.forEach((item, index) => {
            if (index > 8) {
                collects.data.push(item)
            }
        })
    }
    function removeEmptyArrays(arr) {
        return arr.filter(subArr => {
            // 检查每个子数组是否完全为空
            return subArr.some(item => item !== null);
        });
    }
   collects.data = removeEmptyArrays(collects.data)
    collects.celldata = luckysheet.transToCellData(collects.data)
    data.push(collects)
    return data
}
