import {powerdata} from "@/api/power/power.js";
//celldata:表格的celldata的数据  electricity:后端返回的数据  expectedAttributes:需要的数据的中文名字  transform:哪些数据需要加起来
 export function Summary(celldata,electricity,expectedAttributes,transform){
    let obj = []
    let newarray = []
    // 每个属性名代表的意思
    let keyobj = [
        {
            key: 'a11',
            value: '加收管理费'
        },
        {
            key: 'a10',
            value: '照明电量'
        },
        {
            key: 'a6',
            value: '电光电费'
        },
        {
            key: 'a7',
            value: '峰段电量'
        },
        {
            key: 'a13',
            value: '峰段金额'
        },
        {
            key: 'a8',
            value: '平段电量'
        },
        {
            key: 'a14',
            value: '平段金额'
        },
        {
            key: 'a9',
            value: '谷段电量'
        },
        {
            key: 'a15',
            value: '谷段金额'
        },
    ]
    electricity.data.forEach(es => {
        //第一步：把后端返回的数据的对照表的数据的-去除掉  并放入到 cleanedEsDatas中
        let foundAttributes = [];
        let cleanedEsDatas = {};
        Object.entries(es.datas).forEach(([key, v]) => {
            cleanedEsDatas[key] = v && v.replace && v.replace(/-/g, '')
        });
        //第二步：根据后端返回的类别名称跟cleanedEsDatas这个对应上  看中文的数据 在英文里叫什么名字 比如a1=类别
        expectedAttributes.forEach((attrName, index) => {
            let foundKey = Object.keys(cleanedEsDatas).find(key => cleanedEsDatas[key] === attrName);
            if (foundKey) {
                foundAttributes[index] = foundKey;
            } else {
                foundAttributes[index] = null;
            }
        });
        //根据对应上的关系 取详细表所有数据取数并放到一个新数组obj中
        es.details.forEach(element => {
            let funct = {
                key: element[foundAttributes[0]],
                a11: element[foundAttributes[1]],
                a10: element[foundAttributes[2]],
                a16: element[foundAttributes[3]],
                a7:  element[foundAttributes[4]],
                a13: element[foundAttributes[5]],
                a8:  element[foundAttributes[6]],
                a14: element[foundAttributes[7]],
                a9:  element[foundAttributes[8]],
                a15: element[foundAttributes[9]],
                r: '',
            }
                
            //合并的单元格数据  这种格式 transform = [  {host: '管理部门', child: '综合办' }]  key代表类别名称 如果他跟child一样 证明需要合并
            transform.forEach(item => {
                if (funct.key==item.child) {
                    funct.key = item.host;
                }
            });
            obj.push(funct)
        });
    })
    //先根据类别名称跟汇总表的项目挂上钩  找到r行，然后根据每个属性名代表的意思循环obj找到对应的列  创建一个新的数据  只包含了 行列和金额
    keyobj.forEach(keycell => {
        let couloum = celldata.filter(item => item.v && item.v.v && item.v.v == keycell.value)[0].c
        obj.forEach(es => {
            es.r = celldata.filter(item => item.v && item.v.v && item.v.v == es.key)[0]?.r
            let flag1 = ['照明电量', '电光电费'].includes(keycell.value) && !(es.a7 && es.a8 && es.a9)
            if (flag1 || !['照明电量', '电光电费'].includes(keycell.value)) {
                let fun = {
                    r: es.r,
                    c: couloum,
                    value: es[keycell.key]
                }
                if (fun.r && fun.value && fun.value > 0) {
                    newarray.push(fun)
                }
            }
        })
    })
    //把行，列代表k值  如果有重复的就加起来
    let duplicateData = [];
    let seen = new Map();
    // // 根据行列信息合并重复数据并记录索引
    for (let obj of newarray) {
        let key = obj.r + ',' + obj.c;
        if (seen.has(key)) {
            let existingObj = seen.get(key);
            existingObj.value= parseFloat(existingObj.value) + parseFloat(obj.value);
            existingObj.value= (parseInt(existingObj.value) + parseInt(obj.value)).toString();
        } else {
            seen.set(key, obj);
        }
    }
        // 将合并后的数据放入 duplicateData 数组
        for (let obj of seen.values()) {
            if (Math.abs(obj.value) > 0 || Math.abs(parseInt(obj.value)) > 0) {
                duplicateData.push(obj);
            }
        }
        //合并  把处理完的数据合并起来
    celldata.forEach(item=>{
        duplicateData.forEach(obj=>{
            if(obj.r==item.r && obj.c== item.c){
                item.v.v=obj.value
                item.v.m=obj.value
            }
        })
    })
    return celldata
 }