package com.ruoyi.system.controller;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.power.dto.DanHouInquireAboutSubjectAssistance;
import com.ruoyi.system.model.power.dto.DanHouInquireAboutSubjectAssistanceDto;
import com.ruoyi.system.model.power.dto.LinXiInquireAboutSubjectAssistance;
import com.ruoyi.system.service.PowerVoucherConversionService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * 2024/8/1
 * 凭证转换---电力
 */
@RestController
@RequestMapping("/powerVoucherConversion")
public class PowerVoucherConversionController {
    private PowerVoucherConversionService powerVoucherConversionService;

    public PowerVoucherConversionController(PowerVoucherConversionService powerVoucherConversionService) {
        this.powerVoucherConversionService = powerVoucherConversionService;
    }

    /**
     * 林西电力凭证信息查询
     *
     * @param LinXiInquireAboutSubjectAssistance
     * @return
     */
    @PostMapping("/inquireAboutSubjectAssistance")
    public AjaxResult inquireAboutSubjectAssistance(@RequestBody List<LinXiInquireAboutSubjectAssistance> LinXiInquireAboutSubjectAssistance) {
        List<LinXiInquireAboutSubjectAssistance> voList = powerVoucherConversionService.inquireAboutSubjectAssistance(LinXiInquireAboutSubjectAssistance);
        return AjaxResult.success(voList);
    }

    /**
     * 单侯电力凭证信息查询
     * @param danHouInquireAboutSubjectAssistanceDto
     * @return
     */
    @PostMapping("/shanHouVoucherConversion")
    public AjaxResult shanHouVoucherConversion(@RequestBody DanHouInquireAboutSubjectAssistanceDto danHouInquireAboutSubjectAssistanceDto) {
        List<DanHouInquireAboutSubjectAssistance> voList = powerVoucherConversionService.shanHouVoucherConversion(danHouInquireAboutSubjectAssistanceDto);
        return AjaxResult.success(voList);
    }
}
