package com.ruoyi.system.controller;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.salary.LxSalaryModel;
import com.ruoyi.system.service.DhtSalaryService;
import com.ruoyi.system.service.LjtSalaryService;
import com.ruoyi.system.service.LxSalaryService;
import com.ruoyi.system.service.TsSalarySaveService;
import org.checkerframework.checker.units.qual.A;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

@RestController
public class SalaryController {

    private final LxSalaryService lxSalaryService;

    private final DhtSalaryService dhtSalaryService;

    private final LjtSalaryService ljtSalaryService;

    private final TsSalarySaveService salarySaveService;

    public SalaryController(TsSalarySaveService salarySaveService, LxSalaryService lxSalaryService, DhtSalaryService dhtSalaryService, LjtSalaryService ljtSalaryService) {
        this.salarySaveService = salarySaveService;
        this.lxSalaryService = lxSalaryService;
        this.dhtSalaryService = dhtSalaryService;
        this.ljtSalaryService = ljtSalaryService;
    }

    /**
     * 唐山矿
     *
     * @param multipartFile
     * @return
     */
    @PostMapping("/ts/salary")
    public AjaxResult tsSave(@RequestParam("multipartFile") MultipartFile multipartFile, @RequestParam("salaryDate") String salaryDate) {
        return salarySaveService.save(multipartFile, salaryDate);
    }

    /**
     * 林西矿
     *
     * @param multipartFile
     * @return
     */
    @PostMapping("/lx/salary")
    public AjaxResult lxSave(@RequestParam("multipartFile") MultipartFile multipartFile, @RequestParam("salaryDate") String salaryDate) {
        return lxSalaryService.lxSave(multipartFile, salaryDate);
    }

    /**
     * 东欢坨
     *
     * @param multipartFile
     * @param salaryDate
     * @return
     */
    @PostMapping("/dht/salary")
    public AjaxResult dhtSave(@RequestParam("multipartFile") MultipartFile multipartFile, @RequestParam("salaryDate") String salaryDate) {
        return dhtSalaryService.dhtSave(multipartFile, salaryDate);
    }

    /**
     * 吕家坨
     *
     * @param multipartFile
     * @param salaryDate
     * @return
     */
    @PostMapping("/ljt/salary")
    public AjaxResult ljtSave(@RequestParam("multipartFile") MultipartFile multipartFile, @RequestParam("salaryDate") String salaryDate) {
        return ljtSalaryService.ljtSave(multipartFile, salaryDate);
    }
}
