package com.ruoyi.system.controller;

import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.wages.dao.WagesCompilationExcelDAO;
import com.ruoyi.system.service.WagesCompilationService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.util.List;

/**
 * @author haiwe
 * @date 2024/6/7
 */
@RestController
@RequestMapping("/wages/compilation")
@RequiredArgsConstructor
public class WagesCompilationController {
    private final WagesCompilationService wagesCompilationService;

    /**
     * 对照表导入
     * @param file
     * @return
     */
    @PostMapping("/excel")
    public AjaxResult readExcel(@RequestParam("file") MultipartFile file, String type, String mineId) {
        wagesCompilationService.readExcel(file, type, mineId);
        return AjaxResult.success();
    }

    @GetMapping("/list")
    public List<WagesCompilationExcelDAO> getWagesCompilationList() {
        List<WagesCompilationExcelDAO> list = wagesCompilationService.list();
        return list;
    }




}
