package com.ruoyi.system.listener;

import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import com.ruoyi.system.model.salary.DhtSalaryModel;
import com.ruoyi.system.model.salary.LxSalaryModel;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.ArrayList;
import java.util.List;

public class DhtExcelListener<T> extends AnalysisEventListener<T> {

    private final static Logger logger = LoggerFactory.getLogger(DhtExcelListener.class);

    private List<DhtSalaryModel> dhtSalaryModelList = new ArrayList<>();

    private int endRow;

    @Override
    public void invoke(T t, AnalysisContext analysisContext) {
        DhtSalaryModel dhtSalaryModel = (DhtSalaryModel) t;
        if (StringUtils.equals("总计", dhtSalaryModel.getOrg())) {
            endRow = analysisContext.getCurrentRowNum();
        }
        int count = analysisContext.getCurrentRowNum();
        if (endRow == 0 || (endRow - 1 >= count)) {
            dhtSalaryModelList.add(dhtSalaryModel);
        }
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext analysisContext) {
        logger.info("解析完成!");
    }

    public List<DhtSalaryModel> getDhtSalaryModelList() {
        return dhtSalaryModelList;
    }
}
