package com.ruoyi.system.model.wages.dao;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * @author haiwe
 * @date 2024/6/11
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class WagesVersionDAO {
    private static final long serialVersionUID = 1L;

    /** 主键，版本id */
    private Integer versionId;

    /** 版本号 */
    @Excel(name = "版本号")
    private String version;

    /** 是否启用（0：停用，1：启用） */
    @Excel(name = "是否启用", readConverterExp = "0=：停用，1：启用")
    private String openOrClose;

    /** 版本开始时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "版本开始时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date beginTime;

    /** 版本结束时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "版本结束时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date endTime;


}
