package com.ruoyi.system.service.impl;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.mapper.PowerDisplayMapper;
import com.ruoyi.system.model.newrule.NewRuleRequestModel;
import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dao.PowerControlDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;
import com.ruoyi.system.service.PowerDisplayService;
import com.ruoyi.system.service.impl.saveOnTheLargeScreenPower.*;
import org.springframework.stereotype.Service;
import redis.clients.jedis.Jedis;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Optional;
import java.util.concurrent.atomic.AtomicBoolean;
import java.util.stream.Collectors;

/**
 * 2024/7/30
 */
@Service
public class PowerDisplayServiceImpl implements PowerDisplayService {
    private final PowerDisplayMapper powerDisplayMapper;

    PowerDisplayServiceImpl(PowerDisplayMapper powerDisplayMapper) {
        this.powerDisplayMapper = powerDisplayMapper;
    }

    @Override
    public void peek(List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        Jedis redis = new Jedis("192.168.111.226", 6379);
        SysUser user = SecurityUtils.getLoginUser().getUser();
        if (redis.exists("电力导入" + user) && redis.get("电力导入" + user).equals("电力导入大屏")){
            redis.close();
            return;
        }
        redis.set("电力导入" + user, "电力导入大屏");
        redis.expire("电力导入" + user, 5);
        redis.close();
        String mindId = electricityIntoTheParameterDtoDtoList.get(0).getMineid().replaceAll(" ", "");
        List<PowerControlDao> controlList = powerDisplayMapper.selControl(mindId);
        List<PowerDisplayDto> powerDisplayDtoList = new ArrayList<>();
        Class<PowerDisplayDto> powerDisplayDtoClass = PowerDisplayDto.class;
        AtomicBoolean b = new AtomicBoolean(false);
        PowerDisplayDto xs011701 = null;
        electricityIntoTheParameterDtoDtoList.stream().forEach(v -> {
            if (!controlList.parallelStream().anyMatch(a -> a.getColumn().equals(v.getColoumn()))) return;
            PowerDisplayDto displayDto;
            if ("011704".equals(mindId) && v.getRow().equals("电价（含税）")) return;
            if ("010105".equals(mindId) && (v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）") || v.getColoumn().equals("单价")))
                return;
            if ("011701".equals(mindId) && (v.getColoumn().equals("照明电价") || v.getColoumn().equals("动力电价") || v.getRow().contains("多经公司"))) return;
            if (powerDisplayDtoList.size() > 0) {
                powerDisplayDtoList.removeAll(Collections.singleton(null));
                b.set(powerDisplayDtoList.stream().anyMatch(a -> a.getClassificationName().equals(v.getRow())));
            }
            if (b.get()) {
                displayDto = powerDisplayDtoList.stream().filter(a -> a.getClassificationName().equals(v.getRow())).findFirst().get();
            } else {
                displayDto = new PowerDisplayDto();
                displayDto.setClassificationName(v.getRow());
                powerDisplayDtoList.add(displayDto);
            }
            if (mindId.equals("011701") && v.getRow().equals("线损") && v.getColoumn().equals("本月")) {
                xs011701.setPowerTotal(v.getValue());
                return;
            }
            Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
            if (first.isPresent() && first.get().getColumn() != null && first.get().getField() != null) {
                PowerControlDao powerControlDao = first.get();
                try {
                    Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                    method.invoke(displayDto, v.getValue());
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
            b.set(false);
        });
        if (xs011701 != null) powerDisplayDtoList.add(xs011701);
        List<PowerClassificationQueryDao> dao = powerDisplayMapper.selectClassificationToMid(mindId);
        SaveOnTheLargeScreenImpl saveOnTheLargeScreen = null;
        List<String> linXi = Collections.singletonList("011704");
        List<String> lvJiaTuo = Collections.singletonList("011702");
        List<String> danHou = Collections.singletonList("011204");
        List<String> dongHuanTuo = Collections.singletonList("010102");
        List<String> qianJiaYing = Collections.singletonList("010105");
        List<String> fanGeZhuang = Collections.singletonList("011701");
        List<String> tangShanKuang = Collections.singletonList("010101");
        List<String> field = powerDisplayMapper.selField(mindId);
        List<PowerDisplayDto> collect1 = powerDisplayDtoList.parallelStream().filter(v -> !field.contains(v.getClassificationName())).collect(Collectors.toList());
        if (linXi.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().equals("电价（含税）")).collect(Collectors.toList());
            collect.stream().forEach(v -> v.setColoumn(v.getColoumn() + "-费"));
            if (collect.size() != 0) {
                collect.parallelStream().forEach(v -> {
                    Optional<PowerControlDao> first = controlList.parallelStream().filter(a -> a.getColumn().equals(v.getColoumn())).findFirst();
                    try {
                        if (first.isPresent()) {
                            PowerControlDao powerControlDao = first.get();
                            Method method = powerDisplayDtoClass.getMethod("set" + powerControlDao.getField(), String.class);
                            for (PowerDisplayDto displayDto : collect1) {
                                method.invoke(displayDto, v.getValue());
                            }
                        }
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                });
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LinXi());
        } else if (lvJiaTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new LvJiaTuo());
        } else if (danHou.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DanHou());
        } else if (dongHuanTuo.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new DongHuanTuo());
        } else if (qianJiaYing.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList
                    .parallelStream()
                    .filter(v -> v.getRow().contains("（尖）") || v.getRow().contains("（峰）") || v.getRow().contains("（平）") || v.getRow().contains("（谷）"))
                    .collect(Collectors.toList());
            if (collect.size() != 0) {
                PowerDisplayDto displayDto;
                for (NewRuleRequestModel dto : collect) {
                    String[] split = dto.getRow().split("-");
                    Optional<PowerDisplayDto> first = collect1.parallelStream().filter(v -> v.getClassificationName().equals(split[0])).findFirst();
                    if (first.isPresent()) displayDto = first.get();
                    else {
                        displayDto = new PowerDisplayDto();
                        displayDto.setClassificationName(split[0]);
                    }
                    try {
                        Method method = powerDisplayDtoClass.getMethod("set" + dto.getColoumn(), String.class);
                        method.invoke(displayDto, dto.getValue());
                    } catch (Exception e) {
                        e.printStackTrace();
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new QianJiaYing());
        } else if (fanGeZhuang.contains(mindId)) {
            List<NewRuleRequestModel> collect = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getRow().contains("多经公司")).collect(Collectors.toList());
            if (collect.size() != 0) {
                PowerDisplayDto dto = new PowerDisplayDto();
                String[] split = collect.get(0).getRow().split("-");
                dto.setClassificationName(split[0]);
                for (NewRuleRequestModel model : collect) {
                    String[] strings = model.getRow().split("-");
                    switch (strings[1]){
                        case "峰":
                            dto.setPowerPeak(model.getValue());
                            break;
                        case "平":
                            dto.setPowerFlat(model.getValue());
                            break;
                        case "谷":
                            dto.setPowerValley(model.getValue());
                            break;
                        case "尖":
                            dto.setPowerTip(model.getValue());
                            break;
                    }
                }
            }
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new FanGeZhuang());
        } else if (tangShanKuang.contains(mindId)) {
            saveOnTheLargeScreen = new SaveOnTheLargeScreenImpl(new TangShanKuang());
        }
        if (saveOnTheLargeScreen != null) {
            List<PowerDisplayDto> list = saveOnTheLargeScreen.save(mindId, collect1, dao);
            if (mindId.equals("010105")) method(list, electricityIntoTheParameterDtoDtoList);
            if (mindId.equals("011701")) methodFgz(list, electricityIntoTheParameterDtoDtoList);
            list.stream().forEach(v -> {
                if (v.getLevelOneClassification() == null || "".equals(v.getLevelOneClassification()))
                    v.setLevelOneClassification("其他");
                v.setMindId(mindId);
                v.setDateColumn(electricityIntoTheParameterDtoDtoList.get(0).getWageMonth());
            });
            powerDisplayMapper.insert(list);
        }
    }

    /**
     * 011701电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void methodFgz(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        String electricityPricesForLighting = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("照明电价")).findFirst().get().getValue();
        String powerTariff = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> v.getColoumn().equals("动力电价")).findFirst().get().getValue();
        list.parallelStream().forEach(v -> {
            if ((v.getElectricityPriceFlat() != null && !v.getElectricityPriceFlat().equals("")) ||
                    (v.getElectricityPricePeak() != null && !v.getElectricityPricePeak().equals("")) ||
                    (v.getElectricityPriceTip() != null && !v.getElectricityPriceTip().equals("")) ||
                    (v.getElectricityPriceValley() != null && !v.getElectricityPriceValley().equals(""))) return;
            if (v.getLevelThreeClassification().equals("动力用电")) {
                v.setElectricityPriceValley(powerTariff);
                v.setElectricityPriceFlat(powerTariff);
                v.setElectricityPricePeak(powerTariff);
                v.setElectricityPriceTip(powerTariff);
            }
            if (v.getLevelThreeClassification().equals("照明用电")) {
                v.setElectricityPriceValley(electricityPricesForLighting);
                v.setElectricityPriceFlat(electricityPricesForLighting);
                v.setElectricityPricePeak(electricityPricesForLighting);
                v.setElectricityPriceTip(electricityPricesForLighting);
            }
        });
    }

    /**
     * 010105电价的处理方法
     *
     * @param list
     * @param electricityIntoTheParameterDtoDtoList
     */
    private void method(List<PowerDisplayDto> list, List<NewRuleRequestModel> electricityIntoTheParameterDtoDtoList) {
        for (PowerDisplayDto dto : list) {
            if ((dto.getElectricityPriceFlat() == null || dto.getElectricityPriceFlat().equals("")) && (dto.getElectricityPricePeak() == null || dto.getElectricityPricePeak().equals("")) &&
                    (dto.getElectricityPriceTip() == null || dto.getElectricityPriceTip().equals("")) && (dto.getElectricityPriceValley() == null || dto.getElectricityPriceValley().equals(""))) {
                Optional<NewRuleRequestModel> first = electricityIntoTheParameterDtoDtoList.parallelStream().filter(v -> (v.getRow().equals(dto.getLevelOneClassification()) || v.getRow().equals(dto.getLevelTwoClassification())) && v.getColoumn().equals("单价")).findFirst();
                if (first.isPresent()) {
                    NewRuleRequestModel model = first.get();
                    dto.setElectricityPriceValley(model.getValue());
                    dto.setElectricityPriceFlat(model.getValue());
                    dto.setElectricityPricePeak(model.getValue());
                    dto.setElectricityPriceTip(model.getValue());
                }
            }
        }
    }
}
