package com.ruoyi.system.service.impl.saveOnTheLargeScreenPower;

import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;

import java.math.BigDecimal;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * 2024/8/19
 */
public class DanHou implements SaveOnTheLargeScreen{
    @Override
    public List<PowerDisplayDto> save(String mindId, List<PowerDisplayDto> powerDisplayDtoList, List<PowerClassificationQueryDao> dao) {
        powerDisplayDtoList.parallelStream().forEach(v -> {
            for (PowerClassificationQueryDao queryDao : dao) {
                if (v.getClassificationName() != null && v.getClassificationName().equals(queryDao.getClassificationName())) {
                    v.setLevelOneClassification(queryDao.getLevelOneClassification());
                    v.setLevelTwoClassification(queryDao.getLevelTwoClassification());
                    v.setLevelThreeClassification(queryDao.getLevelThreeClassification());
                    break;
                }
            }
        });
        Optional<PowerDisplayDto> first = powerDisplayDtoList.parallelStream().filter(v -> "合计".equals(v.getClassificationName()) && "辅助生产用电".equals(v.getLevelThreeClassification())).findFirst();
        Optional<PowerDisplayDto> first1 = powerDisplayDtoList.parallelStream().filter(v -> "风选厂".equals(v.getClassificationName()) && "风选用电".equals(v.getLevelThreeClassification())).findFirst();
        Optional<PowerDisplayDto> first4 = powerDisplayDtoList.parallelStream().filter(v -> "崔矿供应".equals(v.getClassificationName()) && "辅助生产用电".equals(v.getLevelThreeClassification())).findFirst();
        Optional<PowerDisplayDto> first5 = powerDisplayDtoList.parallelStream().filter(v -> "南留庄供应".equals(v.getClassificationName()) && "辅助生产用电".equals(v.getLevelThreeClassification())).findFirst();
        Optional<PowerDisplayDto> first6 = powerDisplayDtoList.parallelStream().filter(v -> "污水处理场".equals(v.getClassificationName()) && "辅助生产用电".equals(v.getLevelThreeClassification())).findFirst();
        // 减排风
        sub(first, first1, powerDisplayDtoList);
        // 加单侯矿供应
        add(first, first4, powerDisplayDtoList);
        add(first, first5, powerDisplayDtoList);
        add(first, first6, powerDisplayDtoList);
        Optional<PowerDisplayDto> first2 = powerDisplayDtoList.parallelStream().filter(v -> "原煤电量".equals(v.getClassificationName()) && "生产用电".equals(v.getLevelThreeClassification())).findFirst();
        Optional<PowerDisplayDto> first3 = powerDisplayDtoList.parallelStream().filter(v -> "各项小计".equals(v.getClassificationName()) && "排水用电".equals(v.getLevelThreeClassification())).findFirst();
        List<PowerDisplayDto> collect = powerDisplayDtoList.parallelStream().filter(v -> "研发支出".equals(v.getLevelOneClassification())).collect(Collectors.toList());
        // 减排水
        sub(first2, first3, powerDisplayDtoList);
        // 减研发
        if (first2.isPresent() && collect.size() != 0){
            for (PowerDisplayDto dto : collect) {
                sub(first2, Optional.of(dto), powerDisplayDtoList);
            }
        }
        powerDisplayDtoList
                .parallelStream()
                .filter(v -> "各项小计".equals(v.getClassificationName()) && "排水用电".equals(v.getLevelThreeClassification()))
                .forEach(v -> v.setClassificationName("排水"));
        return powerDisplayDtoList;
    }

    private void sub(Optional<PowerDisplayDto> first, Optional<PowerDisplayDto> first1, List<PowerDisplayDto> displayDto) {
        if (first.isPresent() && first1.isPresent()) {
            PowerDisplayDto dto = first.get();
            PowerDisplayDto dto1 = first1.get();
            dto.setPowerTotal(new BigDecimal(dto.getPowerTotal() == null || "".equals(dto.getPowerTotal()) ? "0" : dto.getPowerTotal()).subtract(new BigDecimal(dto1.getPowerTotal() != null && !"".equals(dto1.getPowerTotal()) ? dto1.getPowerTotal() : "0")) + "");
            dto.setElectricityTotal(new BigDecimal(dto.getElectricityTotal() == null || "".equals(dto.getElectricityTotal()) ? "0" : dto.getElectricityTotal()).subtract(new BigDecimal(dto1.getElectricityTotal() != null && !"".equals(dto1.getElectricityTotal()) ? dto1.getElectricityTotal() : "0")) + "");
            displayDto.remove(first.get());
            displayDto.add(dto);
        }
    }

    private void add(Optional<PowerDisplayDto> first, Optional<PowerDisplayDto> first4, List<PowerDisplayDto> displayDto) {
        if (first.isPresent() && first4.isPresent()) {
            PowerDisplayDto dto = first.get();
            PowerDisplayDto dto1 = first4.get();
            dto.setPowerTotal(new BigDecimal(dto.getPowerTotal() == null || "".equals(dto.getPowerTotal()) ? "0" : dto.getPowerTotal()).add(new BigDecimal(dto1.getPowerTotal() != null && !"".equals(dto1.getPowerTotal()) ? dto1.getPowerTotal() : "0")) + "");
            dto.setElectricityTotal(new BigDecimal(dto.getElectricityTotal() == null || "".equals(dto.getElectricityTotal()) ? "0" : dto.getElectricityTotal()).add(new BigDecimal(dto1.getElectricityTotal() != null && !"".equals(dto1.getElectricityTotal()) ? dto1.getElectricityTotal() : "0")) + "");
            displayDto.remove(first.get());
            displayDto.add(dto);
        }
    }
}
