package com.ruoyi.system.service.impl.saveOnTheLargeScreenPower;

import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;
import org.springframework.beans.BeanUtils;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 2024/8/5
 */
public class LinXi implements SaveOnTheLargeScreen {
    @Override
    public List<PowerDisplayDto> save(String mindId, List<PowerDisplayDto> powerDisplayDtoList, List<PowerClassificationQueryDao> dao) {
        List<PowerDisplayDto> list = new ArrayList<>();
        for (PowerDisplayDto powerDisplayDto : powerDisplayDtoList) {
            List<PowerClassificationQueryDao> collect = dao.parallelStream()
                    .filter(a -> a.getClassificationName().equals(powerDisplayDto.getClassificationName()))
                    .collect(Collectors.toList());
            if (collect.size() != 0) {
                for (PowerClassificationQueryDao queryDao : collect) {
                    PowerDisplayDto dto = new PowerDisplayDto();
                    BeanUtils.copyProperties(powerDisplayDto, dto);
                    dto.setLevelOneClassification(queryDao.getLevelOneClassification());
                    dto.setLevelTwoClassification(queryDao.getLevelTwoClassification());
                    list.add(dto);
                }
            } else {
                powerDisplayDto.setLevelOneClassification("其他");
                list.add(powerDisplayDto);
            }
        }
        final String[] tip = new String[1];
        final String[] peak = new String[1];
        final String[] flat = new String[1];
        final String[] valley = new String[1];
        list.parallelStream()
                .forEach(v -> {
                    v.setElectricityTip(v.getElectricityPriceTip() == null || "".equals(v.getElectricityPriceTip()) ? null : new BigDecimal(v.getPowerTip() == null || v.getPowerTip().equals("") ? "0" : v.getPowerTip()).multiply(new BigDecimal(v.getElectricityPriceTip())) + "");
                    v.setElectricityPeak(v.getElectricityPricePeak() == null || "".equals(v.getElectricityPricePeak()) ? null : new BigDecimal(v.getPowerPeak() == null || v.getPowerPeak().equals("") ? "0" : v.getPowerPeak()).multiply(new BigDecimal(v.getElectricityPricePeak())) + "");
                    v.setElectricityFlat(v.getElectricityPriceFlat() == null || "".equals(v.getElectricityPriceFlat()) ? null : new BigDecimal(v.getPowerFlat() == null || v.getPowerFlat().equals("") ? "0" : v.getPowerFlat()).multiply(new BigDecimal(v.getElectricityPriceFlat())) + "");
                    v.setElectricityValley(v.getElectricityPriceValley() == null || "".equals(v.getElectricityPriceValley()) ? null : new BigDecimal(v.getPowerValley() == null || v.getPowerValley().equals("") ? "0" : v.getPowerValley()).multiply(new BigDecimal(v.getElectricityPriceValley())) + "");
                    v.setElectricityTotal(new BigDecimal(v.getElectricityTip() == null || v.getElectricityTip().equals("") ? "0" : v.getElectricityTip()).add(new BigDecimal(v.getElectricityPeak() == null || v.getElectricityPeak().equals("") ? "0" : v.getElectricityPeak())).add(new BigDecimal(v.getElectricityFlat() == null || v.getElectricityFlat().equals("") ? "0" : v.getElectricityFlat())).add(new BigDecimal(v.getElectricityValley() == null || v.getElectricityValley().equals("") ? "0" : v.getElectricityValley())) + "");
                    tip[0] = v.getPowerTip() == null || v.getPowerTip().equals("") ? "0" : v.getPowerTip();
                    peak[0] = v.getPowerPeak() == null || v.getPowerPeak().equals("") ? "0" : v.getPowerPeak();
                    flat[0] = v.getPowerFlat() == null || v.getPowerFlat().equals("") ? "0" : v.getPowerFlat();
                    valley[0] = v.getPowerValley() == null || v.getPowerValley().equals("") ? "0" : v.getPowerValley();
                    v.setPowerTotal(new BigDecimal(tip[0]).add(new BigDecimal(peak[0])).add(new BigDecimal(flat[0])).add(new BigDecimal(valley[0])) + "");
                });
        return list;
    }
}
