package com.ruoyi.system.service.impl.saveOnTheLargeScreenPower;

import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;
import org.apache.commons.lang3.StringUtils;

import java.math.BigDecimal;
import java.util.List;
import java.util.Optional;
import java.util.stream.Collectors;

/**
 * 2024/8/14
 */
public class LvJiaTuo implements SaveOnTheLargeScreen {
    @Override
    public List<PowerDisplayDto> save(String mindId, List<PowerDisplayDto> powerDisplayDtoList, List<PowerClassificationQueryDao> dao) {
        powerDisplayDtoList.parallelStream().forEach(v -> {
            for (PowerClassificationQueryDao queryDao : dao) {
                if (v.getClassificationName() != null && v.getClassificationName().equals(queryDao.getClassificationName())) {
                    v.setLevelOneClassification(queryDao.getLevelOneClassification());
                    v.setLevelTwoClassification(queryDao.getLevelTwoClassification());
                    v.setLevelThreeClassification(queryDao.getLevelThreeClassification());
                    break;
                }
            }
        });
        List<PowerDisplayDto> rDExpendituresOnRawCoal = powerDisplayDtoList.parallelStream().filter(v -> "研发支出".equals(v.getLevelOneClassification()) && v.getLevelThreeClassification().equals("原煤")).collect(Collectors.toList());
        List<PowerDisplayDto> rDSpendingWashesCoal = powerDisplayDtoList.parallelStream().filter(v -> StringUtils.equals(v.getLevelOneClassification(), "研发支出") && "洗煤".equals(v.getLevelThreeClassification())).collect(Collectors.toList());
        Optional<PowerDisplayDto> onRawCoal = powerDisplayDtoList.parallelStream().filter(v -> StringUtils.equals(v.getClassificationName(), "生产成本原煤线电费")).findFirst();
        Optional<PowerDisplayDto> washesCoal = powerDisplayDtoList.parallelStream().filter(v -> StringUtils.equals(v.getClassificationName(), "生产成本洗煤线电费")).findFirst();
        if (onRawCoal.isPresent()) {
            PowerDisplayDto displayDto = onRawCoal.get();
            for (PowerDisplayDto dto : rDExpendituresOnRawCoal) {
                displayDto.setElectricityTotal(new BigDecimal(displayDto.getElectricityTotal()).subtract(new BigDecimal(dto.getElectricityTotal() != null ? dto.getElectricityTotal() : "0")) + "");
                displayDto.setPowerTotal(new BigDecimal(displayDto.getPowerTotal()).subtract(new BigDecimal(dto.getPowerTotal() != null ? dto.getPowerTotal() : "0")) + "");
            }
            powerDisplayDtoList.remove(onRawCoal.get());
            powerDisplayDtoList.add(displayDto);
        }
        if (washesCoal.isPresent()) {
            PowerDisplayDto displayDto = washesCoal.get();
            for (PowerDisplayDto dto : rDSpendingWashesCoal) {
                displayDto.setElectricityTotal(new BigDecimal(displayDto.getElectricityTotal()).subtract(new BigDecimal(dto.getElectricityTotal() != null ? dto.getElectricityTotal() : "0")) + "");
                displayDto.setPowerTotal(new BigDecimal(displayDto.getPowerTotal()).subtract(new BigDecimal(dto.getPowerTotal() != null ? dto.getPowerTotal() : "0")) + "");
            }
            powerDisplayDtoList.remove(washesCoal.get());
            powerDisplayDtoList.add(displayDto);
        }
        return powerDisplayDtoList;
    }
}
