package com.ruoyi.system.service.impl.saveOnTheLargeScreenPower;

import com.ruoyi.system.model.power.dao.PowerClassificationQueryDao;
import com.ruoyi.system.model.power.dto.PowerDisplayDto;

import java.math.BigDecimal;
import java.util.Collections;
import java.util.List;

/**
 * 2024/9/12
 */
public class TangShanKuang implements SaveOnTheLargeScreen{
    @Override
    public List<PowerDisplayDto> save(String mindId, List<PowerDisplayDto> powerDisplayDtoList, List<PowerClassificationQueryDao> dao) {
        powerDisplayDtoList = Collections.synchronizedList(powerDisplayDtoList);
        powerDisplayDtoList.parallelStream().forEach(v -> {
            String[] split = v.getClassificationName().split(",");
            v.setClassificationName(split[0]);
            if (split.length > 1) {
                for (int i = 1; i < split.length; i++) {
                    switch (i){
                        case 1:
                            v.setLevelOneClassification(split[i]);
                            break;
                        case 2:
                            v.setLevelTwoClassification(split[i]);
                            break;
                        case 3:
                            v.setLevelThreeClassification(split[i]);
                            break;
                    }
                }
            }
        });
        powerDisplayDtoList.parallelStream().forEach(v -> {
            if (v.getElectricityTip() != null && v.getPowerTip() != null) v.setElectricityPriceTip(new BigDecimal(v.getElectricityTip()).divide(new BigDecimal(v.getPowerTip())) + "");
            if (v.getElectricityPeak() != null && v.getPowerPeak() != null) v.setElectricityPricePeak(new BigDecimal(v.getElectricityPeak()).divide(new BigDecimal(v.getPowerPeak())) + "");
            if (v.getElectricityValley() != null && v.getPowerValley() != null) v.setElectricityPriceValley(new BigDecimal(v.getElectricityValley()).divide(new BigDecimal(v.getPowerValley())) + "");
            if (v.getElectricityFlat() != null && v.getPowerFlat() != null) v.setElectricityPriceFlat(new BigDecimal(v.getElectricityFlat()).divide(new BigDecimal(v.getPowerFlat())) + "");
        });
        return powerDisplayDtoList;
    }
}
