package com.ruoyi.system.support;


import com.ruoyi.system.constant.CoalConstant;
import com.ruoyi.system.constant.SalaryConstant;
import com.ruoyi.system.model.newrule.NewRuleRequestModel;
import com.ruoyi.system.model.salary.SalaryExcelModel;
import org.apache.commons.lang3.StringUtils;


import java.util.*;
import java.util.function.Function;
import java.util.stream.Collectors;

public class CurrentRuleSalarySupport {


    public final static Map<String, Function<List<NewRuleRequestModel>, List<SalaryExcelModel>>> MINE_MAP = new HashMap<>();

    static {
        MINE_MAP.put(CoalConstant.TS_MINE, CurrentRuleSalarySupport::getTsMineSalaryData);
        MINE_MAP.put(CoalConstant.LJT_MINE, CurrentRuleSalarySupport::getLjtMineSalaryData);
        MINE_MAP.put(CoalConstant.LX_MINE, CurrentRuleSalarySupport::getLxMineSalaryData);
        MINE_MAP.put(CoalConstant.DHT_MINE, CurrentRuleSalarySupport::getDhtMineSalaryData);
        MINE_MAP.put(CoalConstant.SH_MINE, CurrentRuleSalarySupport::getShMineSalaryData);
        MINE_MAP.put(CoalConstant.FK_MINE, CurrentRuleSalarySupport::getFKMineSalaryData);
        MINE_MAP.put(CoalConstant.HF_MINE, CurrentRuleSalarySupport::getHfMineSalaryData);
        MINE_MAP.put(CoalConstant.QJY_MINE, CurrentRuleSalarySupport::getQjyMineSalaryData);
        MINE_MAP.put(CoalConstant.YF_MINE, CurrentRuleSalarySupport::getYfMineSalaryData);
    }

    /**
     * 云飞
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getYfMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 钱家营矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getQjyMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 宏丰
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getHfMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 范各庄矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getFKMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 单侯
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getShMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }


    /**
     * 唐山矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getTsMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);

    }

    /**
     * 吕家坨矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */

    private static List<SalaryExcelModel> getLjtMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 林西矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getLxMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    /**
     * 东欢坨矿
     *
     * @param newRuleSalaryRequestModelList
     * @return
     */
    private static List<SalaryExcelModel> getDhtMineSalaryData(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        return getSalaryMapping(newRuleSalaryRequestModelList);
    }

    public static List<SalaryExcelModel> getSalaryMapping(List<NewRuleRequestModel> newRuleSalaryRequestModelList) {
        List<SalaryExcelModel> salaryExcelModelList = new ArrayList<>();
        for (NewRuleRequestModel newRuleSalaryRequestModel : newRuleSalaryRequestModelList) {
            SalaryExcelModel salaryExcelModel = new SalaryExcelModel();
            String col = newRuleSalaryRequestModel.getColoumn();
            if (SalaryConstant.ORG_SET.contains(col)) {
                salaryExcelModel.setOrg(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.ANNUITY_SET.contains(col)) {
                salaryExcelModel.setAnnuity(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.BIRTH_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setBirthInsurance(newRuleSalaryRequestModel.getValue());
            }
//            if (SalaryConstant.SALARY_SET.contains(col)) {
//                salaryExcelModel.setSalary(newRuleSalaryRequestModel.getValue());
//            }
            if (SalaryConstant.COMPANY_HOUSE_FUND_SET.contains(col)) {
                salaryExcelModel.setCompanyHouseFund(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.EDU_FEES_SET.contains(col)) {
                salaryExcelModel.setEdufFees(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.HEAT_PREVENT_SUBSIDY_SET.contains(col)) {
                salaryExcelModel.setHeatPreventSubsidy(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.HONOR_MONEY_SET.contains(col)) {
                salaryExcelModel.setHonorMoney(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.PERSON_COUNT_SET.contains(col)) {
                salaryExcelModel.setPersonCount(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.MEDICAL_SUBSIDY_SET.contains(col)) {
                salaryExcelModel.setMedicalSubsidy(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.SUMSALARY_SET.contains(col)) {
                salaryExcelModel.setSumSalary(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.OLD_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setOldInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.SINGLE_SUPPLY_MEDICAL_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setSingleSupplyMedicalInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.MEDICAL_INSURANCE_SET.contains(col)) {

                salaryExcelModel.setMedicalInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.SUPPLY_MEDICAL_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setSupplyMedicalInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.UNEMPLOYMENT_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setUnemploymentInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.INJURY_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setInjuryInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.HOUSE_FUND_SET.contains(col)) {
                salaryExcelModel.setHouseFund(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.LABOR_UNION_DUES_SET.contains(col)) {
                salaryExcelModel.setLaborUnionDues(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.oneChild_SET.contains(col)) {
                salaryExcelModel.setOneChild(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.LUNCH_SET.contains(col)) {
                salaryExcelModel.setLunch(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.LONG_ACCOUNT_INSURANCE_SET.contains(col)) {
                salaryExcelModel.setLongAccountInsurance(newRuleSalaryRequestModel.getValue());
            }
            if (SalaryConstant.WARM_SUBSIDY_SET.contains(col)) {
                salaryExcelModel.setWarmSubsidy(newRuleSalaryRequestModel.getValue());
            }
            salaryExcelModel.setOrg(newRuleSalaryRequestModel.getRow());
            salaryExcelModel.setBelongToCoal(newRuleSalaryRequestModel.getMineid());
            salaryExcelModel.setSalaryDate(newRuleSalaryRequestModel.getWageMonth());
            salaryExcelModelList.add(salaryExcelModel);
        }
        List<SalaryExcelModel> finalList = new ArrayList<>();
        Map<String, List<SalaryExcelModel>> collect = salaryExcelModelList.stream().collect(Collectors.groupingBy(SalaryExcelModel::getOrg));
        collect.forEach((k, v) -> {
            SalaryExcelModel salaryExcelModel = mergeData(v);
            finalList.add(salaryExcelModel);
        });
        return finalList;
    }

    public static SalaryExcelModel mergeData(List<SalaryExcelModel> dataList) {
        return dataList.stream().collect(Collectors.collectingAndThen(Collectors.toMap(data -> data.getBelongToCoal() + data.getOrg() + data.getSalaryDate(), data -> data, (existingData, newData) -> {
            existingData.setPersonCount(
                    StringUtils.isEmpty(existingData.getPersonCount()) ? newData.getPersonCount() : existingData.getPersonCount());
            existingData.setMedicalInsurance(
                    StringUtils.isEmpty(existingData.getMedicalInsurance()) ? newData.getMedicalInsurance() : existingData.getMedicalInsurance());
            existingData.setOldInsurance(
                    StringUtils.isEmpty(existingData.getOldInsurance()) ? newData.getOldInsurance() : existingData.getOldInsurance());
            existingData.setUnemploymentInsurance
                    (StringUtils.isEmpty(existingData.getUnemploymentInsurance()) ? newData.getUnemploymentInsurance() : existingData.getUnemploymentInsurance());
            existingData.setSalary(
                    StringUtils.isEmpty(existingData.getSalary()) ? newData.getSalary() : existingData.getSalary());
            existingData.setMedicalSubsidy(
                    StringUtils.isEmpty(existingData.getMedicalSubsidy()) ? newData.getMedicalSubsidy() : existingData.getMedicalSubsidy());
            existingData.setSumSalary(
                    StringUtils.isEmpty(existingData.getSumSalary()) ? newData.getSumSalary() : existingData.getSumSalary());
            existingData.setAnnuity(
                    StringUtils.isEmpty(existingData.getAnnuity()) ? newData.getAnnuity() : existingData.getAnnuity());
            existingData.setSingleSupplyMedicalInsurance(
                    StringUtils.isEmpty(existingData.getSingleSupplyMedicalInsurance()) ? newData.getSingleSupplyMedicalInsurance() : existingData.getSingleSupplyMedicalInsurance());
            existingData.setSupplyMedicalInsurance(
                    StringUtils.isEmpty(existingData.getSupplyMedicalInsurance()) ? newData.getSupplyMedicalInsurance() : existingData.getSupplyMedicalInsurance());
            existingData.setBirthInsurance(
                    StringUtils.isEmpty(existingData.getBirthInsurance()) ? newData.getBirthInsurance() : existingData.getBirthInsurance());
            existingData.setInjuryInsurance(
                    StringUtils.isEmpty(existingData.getInjuryInsurance()) ? newData.getInjuryInsurance() : existingData.getInjuryInsurance());
            existingData.setCompanyHouseFund(
                    StringUtils.isEmpty(existingData.getCompanyHouseFund()) ? newData.getCompanyHouseFund() : existingData.getCompanyHouseFund());
            existingData.setHouseFund(
                    StringUtils.isEmpty(existingData.getHouseFund()) ? newData.getHouseFund() : existingData.getHouseFund());
            existingData.setLaborUnionDues(
                    StringUtils.isEmpty(existingData.getLaborUnionDues()) ? newData.getLaborUnionDues() : existingData.getLaborUnionDues());
            existingData.setEdufFees(
                    StringUtils.isEmpty(existingData.getEdufFees()) ? newData.getEdufFees() : existingData.getEdufFees());
            existingData.setOneChild(
                    StringUtils.isEmpty(existingData.getOneChild()) ? newData.getOneChild() : existingData.getOneChild());
            existingData.setLunch(
                    StringUtils.isEmpty(existingData.getLunch()) ? newData.getLunch() : existingData.getLunch());
            existingData.setLongAccountInsurance(
                    StringUtils.isEmpty(existingData.getLongAccountInsurance()) ? newData.getLongAccountInsurance() : existingData.getLongAccountInsurance());
            existingData.setHonorMoney(
                    StringUtils.isEmpty(existingData.getHonorMoney()) ? newData.getHonorMoney() : existingData.getHonorMoney());
            existingData.setWarmSubsidy(
                    StringUtils.isEmpty(existingData.getWarmSubsidy()) ? newData.getWarmSubsidy() : existingData.getWarmSubsidy());
            existingData.setHeatPreventSubsidy(
                    StringUtils.isEmpty(existingData.getHeatPreventSubsidy()) ? newData.getHeatPreventSubsidy() : existingData.getHeatPreventSubsidy());
            return existingData;
        }), map -> map.values().iterator().next()));
    }

}
