package com.ruoyi.system.support;


import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.system.constant.CoalConstant;
import com.ruoyi.system.mapper.SalaryMapper;
import com.ruoyi.system.model.salary.ActClassModel;
import com.ruoyi.system.model.salary.DhtSalaryModel;
import com.ruoyi.system.model.salary.SalaryExcelModel;
import org.springframework.util.CollectionUtils;

import java.util.ArrayList;
import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

public class DhtSupport {


    public static List<SalaryExcelModel> getSalaryExcelModelList(List<DhtSalaryModel> dhtSalaryModelList, String salaryDate, SalaryMapper salaryMapper) {
        List<SalaryExcelModel> salaryExcelModelList = new ArrayList<>();
        for (DhtSalaryModel dhtSalaryModel : dhtSalaryModelList) {
            SalaryExcelModel salaryExcelModel = new SalaryExcelModel();
            salaryExcelModel.setSumSalary(dhtSalaryModel.getSumSalary());
            salaryExcelModel.setOrg(dhtSalaryModel.getOrg());
            salaryExcelModel.setOldInsurance(dhtSalaryModel.getOldInsurance());
            salaryExcelModel.setPersonCount(dhtSalaryModel.getPersonCount());
            salaryExcelModel.setLunch(dhtSalaryModel.getLunch());
            salaryExcelModel.setOneChild(dhtSalaryModel.getOneChild());
            salaryExcelModel.setSalaryDate(salaryDate);
            salaryExcelModel.setBelongToCoal(CoalConstant.DHT_MINE);
            salaryExcelModel.setMedicalInsurance(dhtSalaryModel.getMedicalInsurance());
            salaryExcelModel.setMedicalSubsidy(dhtSalaryModel.getMedicalSubsidy());
            salaryExcelModel.setHonorMoney(dhtSalaryModel.getHonorMoney());
            salaryExcelModel.setWarmSubsidy(dhtSalaryModel.getWarmSubsidy());
            salaryExcelModel.setSalary(dhtSalaryModel.getSalary());
            salaryExcelModel.setSourceExpenses(getSourceExpensesInfo(salaryMapper, dhtSalaryModel));
            salaryExcelModel.setAnnuity(dhtSalaryModel.getAnnuity());
            salaryExcelModel.setUnemploymentInsurance(dhtSalaryModel.getUnemploymentInsurance());
            salaryExcelModelList.add(salaryExcelModel);
        }
        return salaryExcelModelList;
    }

    private static String getSourceExpensesInfo(SalaryMapper salaryMapper, DhtSalaryModel dhtSalaryModel) {
        String org = dhtSalaryModel.getOrg();
        List<ActClassModel> actClassModelList = salaryMapper.getBySourceDhtClass(Integer.parseInt(CoalConstant.DHT_MINE));
        List<ActClassModel> sourceList = actClassModelList.stream().filter(v -> v.getPid() == null).collect(Collectors.toList());
        List<ActClassModel> orgList = actClassModelList.stream().filter(v -> v.getPid() != null).collect(Collectors.toList());
        List<ActClassModel> collect = orgList.stream().filter(v -> StringUtils.equals(v.getName(), org)).collect(Collectors.toList());
        String name = "";
        if (!CollectionUtils.isEmpty(collect)) {
            Integer pid = collect.get(0).getPid();
            List<ActClassModel> finalCollect = sourceList.stream().filter(v -> Objects.equals(v.getId(), pid)).collect(Collectors.toList());
            name = finalCollect.get(0).getName();
        }
        if(StringUtils.contains(org,"综合服务中心")){
            List<ActClassModel> compositeList = orgList.stream().filter(v -> StringUtils.contains(v.getName(),"综合服务中心")).collect(Collectors.toList());
            Integer pid = compositeList.get(0).getPid();
            List<ActClassModel> finalCollect = sourceList.stream().filter(v -> Objects.equals(v.getId(), pid)).collect(Collectors.toList());
            name = finalCollect.get(0).getName();
        }
        return name;
    }
}
