package com.ruoyi.system.controller;

import com.alibaba.fastjson.JSONObject;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.system.model.wages.dao.WagesDetailsOriginalExcelDAO;
import com.ruoyi.system.model.wages.dto.WagesFormulaListDto;
import com.ruoyi.system.model.wages.vo.WagesFormulaVo;
import com.ruoyi.system.model.wages.vo.WagesLxVo;
import com.ruoyi.system.model.wages.vo.WagesOverviewOriginalDataVO;
import com.ruoyi.system.service.WagesService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;

/**
 * 2024/4/26
 * 工资原始表
 */
@RestController
@RequestMapping("/wages")
public class WagesController {
    private Logger logger = LoggerFactory.getLogger(WagesController.class);

    private WagesService wagesService;

    public WagesController(WagesService wagesService) {
        this.wagesService = wagesService;
    }

    /**
     * 唐山矿excel解析
     * @param file
     * @return
     */
    @PostMapping("/excel")
    public AjaxResult excelAnalysis(@RequestParam("file") MultipartFile file, @RequestParam("date")String date) {
        String s = wagesService.readOriginalData(file, date);
        new AjaxResult();
        return new AjaxResult(200, s);
    }

    /**
     * 工资大略表查询
     * @return
     */
    @PostMapping("/overview")
    public List<WagesOverviewOriginalDataVO> salaries() {
        logger.info("overview");
        List<WagesOverviewOriginalDataVO> salaryList = wagesService.getSalaryList();
        return salaryList;
    }

    /**
     * 工资详情表查询
     * @return
     */
    @RequestMapping("/details")
    public List<WagesDetailsOriginalExcelDAO> details(){
        List<WagesDetailsOriginalExcelDAO> list = wagesService.details();
        return list;
    }

    /**
     *
     */
    @PostMapping("/getyy")
    public AjaxResult getyy(@Validated @RequestBody String s)
    {
        //s = "{\"borrow\":[{\"classary\":\"提取一孩补贴\",\"money\":\"2540\",\"name\":\"基本生产-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"260\",\"name\":\"基本生产-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"1140\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"80\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"730\",\"name\":\"其他业务成本\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"830\",\"name\":\"管理费用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"130\",\"name\":\"劳动保险费-离岗休息\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"377926\",\"name\":\"基本生产-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"14528\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"5046\",\"name\":\"管理费用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"127335.17\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"879604.49\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"36485.62\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"695533.17\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"118219.25\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"18279\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"10471.26\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"8147.41\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"19745.65\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"12687.39\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"7686.7\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"7452.74\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"4693.04\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"3754.43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"288399.99\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"30257.59\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"209013.08\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"8669.77\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"165273.74\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"28091.45\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"4343.51\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"2488.2\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1936\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"4691.99\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"3014.8\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1826.53\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1770.93\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1115.17\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"892.13\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"68530.08\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"20246.73\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"139860.12\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"5801.34\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"110834.63\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"18797.27\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"2663.92\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1664.97\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1295.47\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"3139.63\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"2017.34\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1222.21\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1185.01\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"746.21\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"596.97\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"45856.59\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"1446\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"9992\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"414\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"7918\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"1343\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"234\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"77\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"93\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"224\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"144\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"87\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"85\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"53\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"3276\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"69568.33\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"480563.32\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"19933.56\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"379997.76\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"64587.93\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"9986.56\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"5720.87\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4451.26\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"10787.84\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"6931.63\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4199.55\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4071.73\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"2563.99\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"2051.2\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"157564.52\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"12862.37\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"88850.52\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"3685.48\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"70411.17\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"11941.55\",\"name\":\"管理费用-管理费-原劳保费-离岗休息\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1692.35\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1057.72\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"822.99\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1994.55\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1281.58\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"776.45\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"752.82\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"474.05\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"379.24\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"29131.83\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"99785\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"687996\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"28592\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"371031\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"144855\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"9940\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"6213\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"5479\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"10998\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"8364\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"4844\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"3854\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"3196\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"2557\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"208013\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"9646.78\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"66637.89\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"2764.11\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"52808.37\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"8956.16\",\"name\":\"研发-管理费用-管理费（原劳保费-离岗休息）\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"1269.27\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"793.29\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"617.24\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"1495.91\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"961.18\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"582.34\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"564.61\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"355.54\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"284.43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"21848.87\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"5570.91\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"38482.7\",\"name\":\"制造费用-原煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"1596.25\",\"name\":\"制造费用-洗煤\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"30496.29\",\"name\":\"管理费用-管理费\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"5172.09\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"732.99\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"458.12\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"356.45\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"863.87\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"555.07\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"336.29\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"326.06\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"205.32\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"164.26\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":0,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"12617.5\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":0,\"mining\":\"010101\"}],\"loan\":[{\"classary\":\"提取一孩补贴\",\"money\":\"2540\",\"name\":\"基本生产-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"260\",\"name\":\"基本生产-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"1140\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"80\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"730\",\"name\":\"其他业务成本\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"830\",\"name\":\"管理费用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取一孩补贴\",\"money\":\"130\",\"name\":\"劳动保险费-离岗休息\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"377926\",\"name\":\"基本生产-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"14528\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"班中餐\",\"money\":\"5046\",\"name\":\"管理费用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"127335.17\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"879604.49\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"36485.62\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"695533.17\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"118219.25\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"18279\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"10471.26\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"8147.41\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"19745.65\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"12687.39\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"7686.7\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"7452.74\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"4693.04\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"3754.43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本养老保险\",\"money\":\"288399.99\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"30257.59\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"209013.08\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"8669.77\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"165273.74\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"28091.45\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"4343.51\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"2488.2\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1936\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"4691.99\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"3014.8\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1826.53\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1770.93\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"1115.17\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"892.13\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充养老保险\",\"money\":\"68530.08\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"20246.73\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"139860.12\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"5801.34\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"110834.63\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"18797.27\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"2663.92\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1664.97\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1295.47\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"3139.63\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"2017.34\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1222.21\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"1185.01\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"746.21\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"596.97\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工商保险\",\"money\":\"45856.59\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"1446\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"9992\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"414\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"7918\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"1343\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"234\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"77\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"93\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"224\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"144\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"87\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"85\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"53\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取补充医疗保险\",\"money\":\"3276\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"69568.33\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"480563.32\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"19933.56\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"379997.76\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"64587.93\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"9986.56\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"5720.87\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4451.26\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"10787.84\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"6931.63\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4199.55\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"4071.73\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"2563.99\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"2051.2\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取基本医疗保险\",\"money\":\"157564.52\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"12862.37\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"88850.52\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"3685.48\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"70411.17\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"11941.55\",\"name\":\"管理费用-管理费-原劳保费-离岗休息\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1692.35\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1057.72\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"822.99\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1994.55\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"1281.58\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"776.45\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"752.82\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"474.05\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"379.24\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取工会经费\",\"money\":\"29131.83\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"99785\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"687996\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"28592\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"371031\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"144855\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"9940\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"6213\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"5479\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"10998\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"8364\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"4844\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"3854\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"3196\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"2557\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取住房公积金\",\"money\":\"208013\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"9646.78\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"66637.89\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"2764.11\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"52808.37\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"8956.16\",\"name\":\"研发-管理费用-管理费（原劳保费-离岗休息）\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"1269.27\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"793.29\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"617.24\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"1495.91\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"961.18\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"582.34\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"564.61\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"355.54\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"284.43\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取职工教育经费\",\"money\":\"21848.87\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"5570.91\",\"name\":\"基本生产-洗煤-自产\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"38482.7\",\"name\":\"制造费用-原煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"1596.25\",\"name\":\"制造费用-洗煤\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"30496.29\",\"name\":\"管理费用-管理费\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"5172.09\",\"name\":\"管理费用-劳动保险费-离岗休息人员\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"732.99\",\"name\":\"研发-（1）基于超低浓度瓦斯回热氧化技术的碳减排研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"458.12\",\"name\":\"研发-(2)大倾角高应力厚煤层瓦斯复合动力灾害防控技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"356.45\",\"name\":\"研发-（3）唐山矿城市下压煤充填开采研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"863.87\",\"name\":\"研发-（4）大倾角工作面整体回撤液压支架工艺研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"555.07\",\"name\":\"研发-（5）百年矿井提升机群数字孪生安全运维系统的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"336.29\",\"name\":\"研发-（6）巷道快速修复技术研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"326.06\",\"name\":\"研发-（7）唐山矿风井煤柱区掘进巷道冲击风险判识及监测预警技术研究\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"205.32\",\"name\":\"研发-（8）基于光纤侦听监测预警技术在研判辨识井筒危险因素的研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"164.26\",\"name\":\"研发-（9）矿井副井智能全自动操车系统研究与应用\",\"is_debit\":1,\"mining\":\"010101\"},{\"classary\":\"提取失业保险\",\"money\":\"12617.5\",\"name\":\"其他业务成本-厂区服务\",\"is_debit\":1,\"mining\":\"010101\"}]}";
        //List<WagesSalaryProof> getyy = wagesService.selectWagesVoucherList(s);
        JSONObject of = wagesService.selectWagesVoucherList(s);
        //JSONArray of = JSONArray.of(getyy);
        System.out.println(of);
        return AjaxResult.success(of);
    }

    /**
     * 林西矿工资Excel导入
     * @return
     */
    @RequestMapping("/lxWages")
    public AjaxResult LinXiExcelAnalysisWages(@RequestParam("file") MultipartFile file, @RequestParam String date, @RequestParam String mineId, @RequestParam String identification){
        String s = wagesService.linXiExcelAnalysisWages(file, date, mineId, identification);
        int n = s.equals("请填写excel表类型") ? 500 : s.equals("对照表不完善") ? 500 : 200;
        return new AjaxResult(n, s);
    }


    @PostMapping("/lxSummary")
    public AjaxResult lxSummary(@RequestBody WagesFormulaListDto wagesFormulaListDto){
        List<WagesLxVo> list = wagesService.lxSummary(wagesFormulaListDto);
        if (list == null) {
            return AjaxResult.error("数据为空,请检查查询条件");
        }
        return AjaxResult.success("查询成功",list);
    }


}
